require "defines"

local costTable=require "cost_table"

local barterPeriod=12500
--local barterPeriod=1250

game.oninit(function()onInit()end)
game.onload(function()onLoad()end)
game.onevent(defines.events.onbuiltentity,function(e)onBuiltEntity(e)end)
game.onevent(defines.events.onentitydied,function(e)onRemovedEntity(e)end)
game.onevent(defines.events.onpreplayermineditem,function(e)onRemovedEntity(e)end)

remote.addinterface("barter",{
    alter_cost_table=function(t)
      for n,v in pairs(t) do
        costTable[n]=v
      end
    end,
    performBarter=function()performBarter()end
  });

function onInit()
  if not glob.nextBarter then
    --game.player.print('oninit')
    glob.nextBarter=game.tick-(game.tick%barterPeriod)+barterPeriod
    glob.barterImportChests={}
    glob.barterExportChests={}
  end
end

function onLoad()
  onInit()
end

local function p( msg )
  game.player.print(game.gettext(msg))
end

function onBuiltEntity( event )
  local e=event.createdentity
  if e.name=='import-chest' or e.name=='import-provider-chest' then
    --p('created import chest')
    table.insert(glob.barterImportChests,e)
  end
  if e.name=='export-chest' or e.name=='export-requester-chest' then
    --p('created export chest')
    table.insert(glob.barterExportChests,e)
  end
end

function onRemovedEntity( event )
  local e=event.entity
  if e.name=='import-chest' or e.name=='import-provider-chest' then
    --p('removing import chest')
    for i=1,#glob.barterImportChests do
      if glob.barterImportChests[i].equals(e) then
        --p('removed import chest')
        table.remove(glob.barterImportChests,i)
        break
      end
    end
  end
  if e.name=='export-chest' or e.name=='export-requester-chest' then
    --p('removing export chest')
    for i=1,#glob.barterExportChests do
      if glob.barterExportChests[i].equals(e) then
        --p('removed export chest')
        table.remove(glob.barterExportChests,i)
        break
      end
    end

    --glob.barterExportChests[e]=nil
  end
end

function performBarter()
  local idx,imp=next(glob.barterImportChests,nil)
  if not imp then return end
  local overflow=false
  local soldSomething=false
  local wrongItems=false
  for _,x in ipairs(glob.barterExportChests) do
    if x.valid then
      --p('invalid entity in export chests')
      --break
      if overflow then break end
      local inv=x.getinventory(defines.inventory.chest)
      local cnt=inv.getcontents()
      for k,v in pairs(cnt) do
        local r=costTable[k]
        if r then 
          soldSomething=true
          for name,cost in pairs(r) do
            local total=math.floor(cost*v)
            while total>0 do
              local part=50
              if total<50 then part=total end
              if imp.caninsert{name=name,count=part} then
                imp.insert{name=name,count=part}
                total=total-part
              else
                idx,imp=next(glob.barterImportChests,idx)
                if not imp then
                  overflow=true
                  break
                end
              end
            end
            inv.remove{name=k,count=v}
            if overflow then break end
          end
        else
          wrongItems=true
        end
        if overflow then break end
      end
    end
  end
  if overflow then
    p('barter-overflow')
  else
    if wrongItems then
      if soldSomething then
        p('barter-successful-invitems')
      else
        p('barter-invitems')
      end
    else
      if soldSomething then
        p('barter-successful')
      end
    end
  end
end

game.onevent(defines.events.ontick, function ( event )
  if game.tick > glob.nextBarter then
    glob.nextBarter=glob.nextBarter+barterPeriod
    performBarter()
  end
end)
