use strict;
$|=1;

use constant basePercent=>1.05;

my $res={
  'copper-ore'=>{basic=>1},
  'iron-ore'=>{basic=>1},
  'stone'=>{basic=>1},
  'coal'=>{basic=>1},
  'sulfur'=>{basic=>1},
  'plastic-bar'=>{basic=>1},
  'raw-wood'=>{basic=>1},
  'alien-artifact'=>{basic=>1},
  'water'=>{ignore=>1},
  'crude-oil'=>{disabled=>1},
  'lubricant'=>{disabled=>1}
};

#for my $v(values(%$res))
#{
#  $v->{amount}=basePercent if $v->{basic};
#}

my $curname;
my $curingr;
my $skip=0;
while(<>)
{
  if(/^END/)
  {
    if($skip)
    {
      $skip=0;
      next;
    }
    $res->{$curname}=$curingr;
    next;
  }
  next if $skip;
  if(/(^[\w\-]+)(?:\[(\d+(?:\.\d+)?)\])?=/)
  {
    if($res->{$1})
    {
      $skip=1;
      next;
    }
    $curname=$1;
    my $amount=$2?$2*1.0:1.0;
    print "loading $curname, amount=$amount\n";
    $curingr={amount=>$amount,arr=>[]};
  }elsif (/([\w\-]+):(\d+(?:\.\d+)?)/)
  {
    if($1 eq 'energy')
    {
      $curingr->{energy}=$2;
    }else
    {
      push @{$curingr->{arr}},{name=>$1,amount=>$2};
      print "add ing $1, amount=$2\n";
    }
  }elsif(/([\w\-]+)(\[[\d\.]+\])?,/)
  {
    print "wtf:$1\n";
    while(/([\w\-]+)(\[[\d\.]+\])?[,=]/g)
    {
      next if $res->{$1};
      print "disable $1\n";
      $res->{$1}={disabled=>1};
    }
    $skip=1;
  }else
  {
    print "not recognized!!!:$_\n";
  }
}

my $done=0;
while(!$done)
{
  $done=1;
  for my $k(keys(%$res))
  {
    my $v=$res->{$k};
    next if $v->{basic};
    next if $v->{complete};
    next if $v->{ignore};
    next if $v->{disabled};
    print "processing:$k\n";
    my $expanded=[];
    my $allexpanded=1;
    for my $i(@{$v->{arr}})
    {
      my $r=$res->{$i->{name}};
      if($r->{disabled})
      {
        $expanded=$v->{arr};
        $i->{disabled}=1;
        $v->{disabled}=1;
        $allexpanded=0;
        last;
      }
      if($r->{ignore})
      {
        next;
      }
      if($r->{basic})
      {
        if($i->{basic})
        {
          push @$expanded,$i;
        }else
        {
          my $mul=basePercent;
          if($v->{energy})
          {
            $mul+=$v->{energy}/100.0;
          }
          push @$expanded,{name=>$i->{name}, basic=>1, amount=>$mul*$i->{amount}/$v->{amount}};
          print "basic $i->{name}, amount=$expanded->[-1]->{amount}\n";
        }
      }else
      {
        print "expand $i->{name}:\n";
        $done=0;
        $allexpanded=0;
        if(!$r->{complete})
        {
          print "$i->{name} is not yet complete\n";
          push @$expanded,$i;
        }else
        {
          for my $l(@{$r->{arr}})
          {
            my $mul=basePercent;
            if($v->{energy})
            {
              $mul+=$v->{energy}/100.0;
            }
            push @$expanded,{name=>$l->{name},basic=>($l->{basic} || $r->{basic}), amount=>$mul*$i->{amount}*$l->{amount}/$v->{amount}};
            print "$l->{name}, amount=$expanded->[-1]->{amount}\n";
          }
        }
      }
    }
    $v->{arr}=$expanded;
    if($allexpanded)
    {
      my $c={};
      for my $i(@$expanded)
      {
        $c->{$i->{name}}+=$i->{amount};
      }
      $expanded=[];
      for my $k(keys(%$c))
      {
        push @$expanded,{name=>$k,basic=>$res->{$k}->{basic}?1:0,amount=>$c->{$k}};
      }
      $v->{arr}=$expanded;
      print "$k complete\n";
      $v->{complete}=1;
    }
  }
}

open(my $f,'>cost_table.lua');
print $f "return {\n";
for my $k(keys(%$res))
{
  my $r=$res->{$k};
  next if $r->{disabled} || $r->{basic} || $r->{ignore};
  print $f "  ['$k']={\n";
  for my $i(@{$r->{arr}})
  {
    print $f "    ['$i->{name}']=$i->{amount},\n";
  }
  print $f "  },\n";
}
print $f "}\n";
close $f;


#use Data::Dumper;
#$Data::Dumper::Indent=1;
#print Dumper($res);
